import java.io.*;
import javax.microedition.rms.*;
import javax.microedition.lcdui.*;

public class ServerOptions extends Form {

    public TextField host, pass;
    public ChoiceGroup mode;
    
    public ServerOptions() {
        super("Vidance Options");
        host=new TextField("Host","host:port",32,TextField.ANY);
        pass=new TextField("Password","",12,TextField.PASSWORD); 
        mode=new ChoiceGroup("Color mode",ChoiceGroup.EXCLUSIVE);
        mode.append("Server's",null);
        mode.append("Best guess",null);
        mode.append("BGR233",null);
        mode.append("8bit Map",null);
        mode.append("16bit",null);
        mode.append("24bit",null);
        mode.setSelectedIndex(1,true);

        try {
            RecordStore rs=RecordStore.openRecordStore("opts",false);
            RecordEnumeration re=rs.enumerateRecords(null,null,false);
            byte[] b=re.nextRecord();
            DataInputStream dis=new DataInputStream
                (new ByteArrayInputStream(b));
            String hp=dis.readUTF();
            String pw=dis.readUTF();
            int m=dis.read();
            if(m==-1) m=0;
            host.setString(hp);
            pass.setString(pw);
            mode.setSelectedIndex(m,true);
            re.destroy();
            dis.close();
            rs.closeRecordStore();
        } catch(Exception e) {
            e.printStackTrace();
        }
        append(host);
        append(pass);
        append(mode);
    }

    public void save() {
        try { 
            RecordStore.deleteRecordStore("opts"); 
        } catch(Exception e) {
            e.printStackTrace(); 
        }
        try {
            RecordStore rs=RecordStore.openRecordStore("opts",true);
            ByteArrayOutputStream baos=new ByteArrayOutputStream();
            DataOutputStream dos=new DataOutputStream(baos);
            dos.writeUTF(host.getString());
            dos.writeUTF(pass.getString());
            dos.write(mode.getSelectedIndex());
            dos.close();
            byte[] b=baos.toByteArray();
            rs.addRecord(b,0,b.length);
            rs.closeRecordStore();
        } catch(Exception e) {
            e.printStackTrace();
        }
        System.gc();
    }

    public String getHost() { return host.getString(); }
    public String getPass() { return pass.getString(); }
    public int getMode() { return mode.getSelectedIndex(); }
}

