import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class Vidance extends MIDlet implements CommandListener {
    private VidanceCanvas vc;
    private ServerOptions so;
    private Display disp;
    private Command soexit, soconn;
    
    public Vidance() {
        disp=Display.getDisplay(this);
        soconn=new Command("Ok",Command.OK,1);
        soexit=new Command("Exit",Command.EXIT,2);
        so=new ServerOptions();
        so.addCommand(soconn);
        so.addCommand(soexit);
        so.setCommandListener(this);
        disp.setCurrent(so);
    }

    public void runApp() {
        if(vc==null) vc=new VidanceCanvas();
        vc.init();
        String host=so.getHost(), pass=so.getPass();
        vc.setDisplay(disp);
        vc.setColorMode(so.getMode());
        so.save();
        System.gc();
        disp.setCurrent(vc);
        int t=vc.connect(host,pass);
        switch(t) {
            case 0: 
                synchronized(vc) {
                    try { vc.wait(); } catch(InterruptedException e) {}
                    if(vc.hasError()) displayError("Terminated","Process ended: "+vc.getError());
                    else disp.setCurrent(so);
                }
                System.gc();
                break;
            case 1: displayError("Connection failed",
                            "Failure during handshake");
                    break;
            case 2: displayError("Authentication failed","Wrong password?");
                    break;
            case 3: displayError("Bad color mode","Too many bytes per color");
                    break;
            case -1: displayError("Exception",
                             "Exception occurred during connect(): "
                             +vc.getError());
                     break;
            default: displayError("Unknown error code","Error code: "+t);
                     break;
        }
    }
    
    public void startApp() {}
    public void pauseApp() {}
    public void destroyApp(boolean b) {}
    public void commandAction(Command c, Displayable d) {
        if(c==soexit) notifyDestroyed();
        else if(c==soconn) 
            new Thread() { 
            public void run() { runApp(); } 
        }.start();
    }

    public void displayError(String title, String text) {
        Alert al=new Alert(title,text,null,AlertType.ERROR);
        al.setTimeout(al.FOREVER);
        disp.setCurrent(al,so);
    }
}


